      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     include files
;**********************************************************************     
      include \Altra32\include\windows.inc
      include \Altra32\include\user32.inc
      include \Altra32\include\kernel32.inc
      include \Altra32\include\comdlg32.inc
      include \Altra32\include\Comctl32.inc
      include \Altra32\include\vfw32.inc

;**********************************************************************
; Local prototypes
;**********************************************************************
        WinMain                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WinProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA               PROTO C :DWORD,:VARARG

        wsprintf equ <wsprintfA>

;**********************************************************************
; Local macros
;**********************************************************************
include \altra32\macros\macros.asm
;**********************************************************************
; Public symbols
;**********************************************************************

PUBLIC hWnd
PUBLIC hIcon
PUBLIC szAppName


EXTERN hInstance:DWORD
;**********************************************************************
; Place all your Constance's here.
;**********************************************************************
.const
ICO_MAINICON     equ 500
app_width        equ 350
app_height       equ 315

;**********************************************************************
; Inishilized DATA
;**********************************************************************
.data
szClassName      db "VCam_Class",0
szAppName        db "Cam Demo",0
szVideoName      db "Demo Cap",0

;**********************************************************************
; Un-Inishilized DATA
;**********************************************************************
.data?
hCap             dd ?
hWnd             dd ?
hIcon            dd ?
CommandLine      dd ?
cp               CAPTUREPARMS<?>

.code
;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
WinMain proc hModule:DWORD,hPrevInstance:DWORD,lpCmdLine:DWORD,nCmdShow:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

        invoke LoadIcon,hModule,ICO_MAINICON    ; icon ID
        mov hIcon,eax
        mov wc.cbSize,sizeof WNDCLASSEX
        mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,offset WinProc
        mov wc.cbClsExtra,NULL
        mov wc.cbWndExtra,NULL
        mov eax,hModule
        mov wc.hInstance,eax
        mov wc.hbrBackground,COLOR_BTNFACE+1
        mov wc.lpszMenuName,NULL
        mov wc.lpszClassName,offset szClassName
        mov eax,hIcon
        mov wc.hIcon,eax
        mov wc.hIconSm,eax
        invoke LoadCursor,NULL,IDC_ARROW
        mov wc.hCursor,eax
        invoke RegisterClassEx, addr wc
        invoke CreateWindowEx,WS_EX_LEFT,addr szClassName,addr szAppName,WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,0,0,app_width,app_height,NULL,NULL,hModule,NULL
        mov hWnd,eax
        invoke ShowWindow,hWnd,SW_SHOWNORMAL
        invoke UpdateWindow,hWnd
        ;********************************************************************
        ; The code for this CAM control doe not have to go here, it can go
        ; into the main PROC or anywhere, I just put it here so that the
        ; window will show right away so the user knows it's working
        ; couse some cam's take awhile to startup.
        ;********************************************************************
        invoke capCreateCaptureWindow,addr szVideoName,
                                      WS_BORDER or WS_CHILD or WS_VISIBLE,
                                      10,20,320,240,hWnd,2000
       
         mov [hCap],eax
         invoke SendMessage,hCap,WM_CAP_DRIVER_CONNECT,0,0
         invoke SendMessage,hCap,WM_CAP_GET_SEQUENCE_SETUP,sizeof cp,addr cp
         mov [cp.fStepCaptureAt2x],TRUE
         invoke SendMessage,hCap,WM_CAP_DLG_VIDEODISPLAY,0,0
         invoke SendMessage,hCap,WM_CAP_SET_SEQUENCE_SETUP,sizeof cp,addr cp
         invoke SendMessage,hCap,WM_CAP_SET_SCALE,TRUE,0
         invoke SendMessage,hCap,WM_CAP_SET_PREVIEWRATE,60,0
         invoke SendMessage,hCap,WM_CAP_SET_PREVIEW,TRUE,0

StartLoop:
        invoke GetMessage,addr msg,NULL,0,0
        cmp eax,0
        je ExitLoop
        invoke TranslateMessage,addr msg
        invoke DispatchMessage, addr msg
        jmp StartLoop
ExitLoop:
        return msg.wParam
WinMain endp

end
